package nl.fampennings.timer;

import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class TimerActivity extends Activity {

    TextView mTextView;
    Button   mButtonStart;
    Button   mButtonStop;

    int      mCount;
    Timer    mTimer;

    Handler  mHandler= new Handler();
    
    Runnable TheDelegatedTimerTask= new Runnable() {
        @Override public void run() {
            mCount++; 
            mTextView.setText("Count="+mCount);
        }
    };

    protected class TheTimerTask extends TimerTask {
        @Override public void run() {
            // What we want to say is
            //  mCount++; 
            //  mTextView.setText("Count="+mCount);
            // But this gives "Only the original thread that created a view hierarchy can touch its views."
            mHandler.post(TheDelegatedTimerTask);
        }
    }
    
    protected void timerStart() {
        if( mTimer==null ) {
            mTimer = new Timer();
            mTimer.schedule( new TheTimerTask(), 0, 100 ); // 100 milli seconds
        }
    }

    protected void timerStop() {
        if( mTimer!=null ) {
            mTimer.cancel(); 
            mTimer= null;
        }
    }

    
    OnClickListener mButtonStart_OnClick = new OnClickListener() {
        @Override public void onClick(View v) {
            mCount= 0;
            timerStart();
        }
    };
    
    OnClickListener mButtonStop_OnClick = new OnClickListener() {
        @Override public void onClick(View v) {
            timerStop();
        }
    };

    
    @Override public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        mTextView= (TextView)findViewById(R.id.textview);
        mButtonStart= (Button)findViewById(R.id.buttonstart);
        mButtonStop= (Button)findViewById(R.id.buttonstop);

        mButtonStart.setOnClickListener(mButtonStart_OnClick);
        mButtonStop.setOnClickListener(mButtonStop_OnClick);

    }
}